﻿using System;
using System.IO;
using System.Security.Cryptography;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;

namespace XmlSign
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void button1_Click(object sender, EventArgs e)
		{
			RSA rsa = RSA.Create();

			this.privateKeyTextBox.Text = rsa.ToXmlString(true);
			this.publicKeyTextBox.Text = rsa.ToXmlString(false);
		}

		private void button2_Click(object sender, EventArgs e)
		{
			LicenseInformation information = new LicenseInformation
			                                 	{
			                                 		RegistrationDate = DateTime.Now,
			                                 		ValidUntil = DateTime.Now.AddYears(1),
			                                 		LicenseOwner = "Chuck Norris"
			                                 	};

			XmlSerializer ser = new XmlSerializer(information.GetType());
			StringWriter streamWriter = new StringWriter();
			ser.Serialize(streamWriter, information);

			this.xmlToSignTextBox.Text = streamWriter.ToString();
		}

		private void button3_Click(object sender, EventArgs e)
		{
			XmlDocument xmlDocument = new XmlDocument();
			xmlDocument.LoadXml(this.xmlToSignTextBox.Text);

			this.signedXml.Text = XmlSign.Sign(xmlDocument, this.privateKeyTextBox.Text);
		}

		private void button4_Click(object sender, EventArgs e)
		{
			try
			{
				if (XmlSign.Verify(this.signedXml.Text, this.publicKeyTextBox.Text))
				{
					MessageBox.Show("Signature is valid!");
				}
				else
				{
					MessageBox.Show("Signature is not valid!");
				}
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error while validating: " + ex.ToString());
			}
		}
	}



	public class LicenseInformation
	{
		public DateTime RegistrationDate { get; set; }
		public DateTime ValidUntil { get; set; }
		public string LicenseOwner { get; set; }
	}
}
